# -*- coding: utf-8 -*-
import xbmcplugin, xbmcgui
import xbmc, pprint
try:
	from urllib import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urllib import urlencode
except ImportError:
	from urllib.parse import urlencode
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
import re
import json
import xml.etree.ElementTree as ET
import datetime, time
from youtube_dl import YoutubeDL
import youtube
import youku
import iqiyi

###############################################################################
# FIX: xbmcout instance in sys.stderr does not have isatty(), so we add it
###############################################################################

class replacement_stderr(sys.stderr.__class__):
	def isatty(self):
		return False
sys.stderr.__class__ = replacement_stderr

###############################################################################
# FIXES: datetime.datetime.strptime evaluating as None in Kodi
###############################################################################

class new_datetime(datetime.datetime):
	@classmethod
	def strptime(cls, dstring, dformat):
		return datetime.datetime(*(time.strptime(dstring, dformat)[0:6]))
datetime.datetime = new_datetime

def httpget(url):
	try:
		return urlopen(url).read()
	except:
		print url
		print 'captured'
		return False

def item(para, isFolder = True):
	for k in para:
		if isinstance(para[k], unicode):
			para[k] = para[k].encode('utf-8')
	title = ''
	if 'title' in para:
		title = para['title']
	listitem = xbmcgui.ListItem(title)
	xbmcplugin.addDirectoryItem(handle, sys.argv[0] + '?' + urlencode(para), listitem, isFolder)

def play(title, url):
	listitem = xbmcgui.ListItem(title)
	xbmc.Player().play(url, listitem)

def error(code):
	xbmcgui.Dialog().ok('Error', 'Error code: ' + code)
	sys.exit(0)

def node(elem):
	if len(elem):
		ret = {elem.tag: []}
		for e in elem:
			ret[elem.tag].append(node(e))
		return ret
	return {elem.tag: elem.text}
	#ret = {elem.tag}
	#xbmc.log(elem.tag, xbmc.LOGNOTICE)
	#xbmc.log(str(len(elem)), xbmc.LOGNOTICE)
	#for e in elem:
	#	node(e)
#def node(elem):
#	#xbmc.log(pprint.pformat(elem), xbmc.LOGNOTICE)
#	#xbmc.log(elem.tagName, xbmc.LOGNOTICE)
#	#for i in elem.childNodes:
#	#	if i.nodeType == i.ELEMENT_NODE:
#	#		xbmc.log(pprint.pformat(i), xbmc.LOGNOTICE)
#	if elem.nodeType = elem.ELEMENT_NODE:
#		if elem.tagName == 'folder':
#			xbmc.log(pprint.pformat(elem.getElementsByTagName('title')), xbmc.LOGNOTICE)
#			#ret = {'title'}
#			#for e in elem.childNodes:
#			#	r = node(e)
#			#	if r:
#			#		ret.append(r)
#	return None
	
def response(para):
	if 'json' in para:
		ret = json.loads(para['json'])
		xbmc.log(json.dumps(ret), xbmc.LOGNOTICE)
		for i in ret:
			if i == 'folder':
				for j in ret[i][1:]:
					para = {}
					for k in j:
						para['title'] = j[k][0]['title']
						break
					para['json'] = json.dumps(j)
					item(para)
			if i == 'item':
				para = {}
				for j in ret[i]:
					for k in j:
						if k == 'title':
							para['title'] = j[k]
						if k == 'url':
							para['url'] = j[k]
				response(para)
		xbmcplugin.endOfDirectory(handle)
		return
	if 'url' not in para:
		error('100')
	url = para['url']
	if 'play' in para:
		play('', url)
		return
	o = urlparse(url)
	p = o.path.split('/')
	q = parse_qs(o.query)
	l = len(p)
	ret = None
	if o.netloc == 'www.youtube.com':
		if l == 2 and p[1] == 'playlist' and'list' in q:
			ret = youtube.playlist(url)
		if l == 3 and (p[1] == 'user' or p[1] == 'channel'):
			ret = youtube.user(url)
		if l == 4 and (p[1] == 'user' or p[1] == 'channel') and p[-1] == 'videos':
			ret = youtube.uservideos(url)
		if l == 4 and (p[1] == 'user' or p[1] == 'channel') and p[-1] == 'playlists':
			ret = youtube.userplaylists(url)
		if l == 2 and p[1] == 'browse_ajax':
			ret = youtube.loadmore(url)
	elif re.match(r'http://www\.youku\.com/show_page/.*\.html', url):
		ret = youku.show_page(url)
	elif re.match(r'http://www\.youku\.com/show_episode/.*', url):
		ret = youku.show_episode(url)
	elif re.match(r'http://www\.youku\.com/playlist_show/.*\.html', url):
		ret = youku.playlist(url)
	elif re.match(r'http://list\.youku\.com/show/id.*', url):
		ret = youku.list_show_id(url)
	elif re.match(r'http://list\.youku\.com/show/episode.*', url):
		ret = youku.list_show_episode(url)
	elif re.match(r'http://www\.iqiyi\.com/a_.*\.html', url):
		ret = iqiyi.get(url)
	if ret:
		if ret['success'] == False:
			error(ret['code'])
		for elem in ret['item']:
			item(elem)
		xbmcplugin.endOfDirectory(handle)
		return
	ie_key = None
	if 'ie_key' in para:
		ie_key = para['ie_key']
	ret = YoutubeDL({'extract_flat': True}).extract_info(url, download = False, ie_key = ie_key)
	#xbmc.log(pprint.pformat(ret), xbmc.LOGNOTICE)
	if '_type' in ret:
		if ret['_type'] == 'playlist':
			if 'entries' not in ret:
				error('101')
			for elem in ret['entries']:
				item(elem)
		elif ret['_type'] == 'url':
			response(ret)
			return
	elif 'formats' in ret:
		for elem in ret['formats']:
			elem['title'] = elem['format']
			elem['play'] = True
			item(elem, False)
	xbmcplugin.endOfDirectory(handle)

handle = int(sys.argv[1])
if sys.argv[2] == '':
	url = 'http://ims.tian-le.com/youtubedl.xml'
	content = httpget(url)
	if content == False:
		error('000')
	try:
		root = ET.fromstring(content)
	except:
		error('001')
	ret = node(root)
	para = {'json': json.dumps(ret)}
	response(para)
else:
	url = sys.argv[2]
	o = urlparse(url)
	q = parse_qs(o.query)
	para = {}
	for k in q:
		para[k] = q[k][0]
	response(para)
