# -*- coding: utf-8 -*-
import re, json, time
try:
	from urllib2 import urlopen, Request
except ImportError:
	from urllib.request import urlopen, Request
try:
	from urllib import quote
except ImportError:
	from urllib.parse import quote
try:
	from HTMLParser import HTMLParser
except ImportError:
	from html.parser import HTMLParser

def httpget(url, referer = None):
	try:
		request = Request(url)
		if referer != None:
			request.add_header('Referer', referer)
		content = urlopen(request).read()
		content = content.decode('utf-8')
		return content
	except:
		print(url)
		print('captured')
		return False

def show_page(url):
	id = re.search('http://www.youku.com/show_page/id_(.*?)\.html', url)
	if id == None:
		return {'success': False, 'code':'youku 200'}
	id = id.group(1)
	url = 'http://list.youku.com/show/id_' + id + '.html'
	return list_show_id(url)

def list_show_id(url):
	id = re.search('http://list.youku.com/show/id_(.*?)\.html', url)
	if id == None:
		return {'success': False, 'code':'youku 200'}
	id = id.group(1)
	url = 'http://list.youku.com/show/id_' + id + '.html'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 201'}
	showid = re.search('showid:"(.*?)"', content)
	if showid == None:
		return {'success': False, 'code':'youku 202'}
	showid = showid.group(1)
	url = 'http://list.youku.com/show/module?id=' + showid + '&tab=showInfo&callback=callback'
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 203'}
	content = re.search('\((.*)\)', content)
	if content == None:
		return {'success': False, 'code':'youku 204'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youku 205'}
	html = data['html']
	result = {'success': True, 'item': []}
	ul = re.search('<ul.*?>(.*?)</ul>', html)
	if ul == None:
		return {'success': False, 'code':'youku 206'}
	ul = ul.group(1)
	m = re.findall('<li(.*?)>(.*?)</li>', ul)
	if m:
		for e in m:
			dataid = re.search('data-id="(.*?)"', e[0])
			if dataid:
				dataid = dataid.group(1)
				url = 'http://list.youku.com/show/episode?id=' + showid + '&stage=' + dataid + '&callback=callback'
				result['item'].append({'title': HTMLParser().unescape(e[1]), 'url': url})
			a = re.search('<a(.*?)>(.*?)</a>', e[1])
			if a:
				href = re.search('href="(.*?)"', a.group(1))
				if href:
					url = href.group(1)
					if url[0:2] == '//':
						url = 'http:' + url
					result['item'].append({'title': HTMLParser().unescape(a.group(2)), 'url': url})
	return result

def list_show_episode(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 220'}
	content = re.search('\((.*)\)', content)
	if content == None:
		return {'success': False, 'code':'youku 221'}
	content = content.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youku 222'}
	html = data['html']
	result = {'success': True, 'item': []}
	m = re.findall('<a.*?href="(.*?)".*?>(.*?)</a>', html)
	if m:
		for e in m:
			url = e[0]
			if url[0:2] == '//':
				url = 'http:' + url
			result['item'].append({'title': HTMLParser().unescape(e[1]), 'url': url})
	return result

def show_episode(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 300'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul.*?>(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*>(.*?)</a>', e)
		if s == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(s.group(2)), 'url': s.group(1)})
	return result

def playlist(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youku 400'}
	result = {'success': True, 'item': []}
	m = re.findall('<ul class="v">(.*?)</ul>', content, re.DOTALL)
	for e in m:
		s = re.search('<a [^<>]*title="(.*?)"[^<>]*href="(.*?)"[^<>]*>', e)
		if s == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(s.group(1)), 'url': s.group(2)})
	s = re.search('<div class="page f_r">(.*?)</div>', content, re.DOTALL)
	if s:
		s = re.search('<a [^<>]*href="(.*?)"[^<>]*title=\'下一页\'[^<>]*>', s.group(1))
		if s:
			result['item'].append({'title': 'Load more', 'url': s.group(1)})
	return result

def play(url):
	def quote_cna(cna):
		if '%' in cna:
			return cna
		return quote(cna)
	def fetch_cna():
		url = 'http://log.mmstat.com/eg.js'
		try:
			req = urlopen(url)
		except e:
			raise e
		for header in req.info():
			if header.lower() == 'set-cookie':
				n_v = req.info()[header].split(';')[0]
				name, value = n_v.split('=')
				if name == 'cna':
					return quote_cna(value)
		return quote_cna('DOG4EdW4qzsCAbZyXbU+t7Jt')
	vid = re.search('http://v.youku.com/v_show/id_(.*?)\.html', url)
	if vid == None:
		return {'success': False, 'code':'youku 100'}
	vid = vid.group(1)
	ccode = '0401'
	try:
		url = 'https://ups.youku.com/ups/get.json?vid=' + vid + '&ccode=' + ccode
		url += '&client_ip=192.168.1.1'
		url += '&utid=' + fetch_cna()
		url += '&client_ts=' + str(int(time.time()))
	except:
		return {'success': False, 'code':'youku 101'}
	content = httpget(url, referer = 'http://v.youku.com')
	if content == False:
		return {'success': False, 'code':'youku 102'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youku 103'}
	result = {'success': True, 'title': data['data']['video']['title'], 'url': {}}
	for stream in data['data']['stream']:
		result['url'][stream['stream_type']] = []
		for seg in stream['segs']:
			result['url'][stream['stream_type']].append((seg['cdn_url']))
	return result
