# -*- coding: utf-8 -*-
import re, json
try:
	from urllib2 import urlopen
except ImportError:
	from urllib.request import urlopen
try:
	from urlparse import urlparse, parse_qs
except ImportError:
	from urllib.parse import urlparse, parse_qs
try:
	from HTMLParser import HTMLParser
except ImportError:
	from html.parser import HTMLParser

def httpget(url):
	try:
		return urlopen(url).read().decode('utf-8')
	except:
		return False

def playlist(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 200'}
	result = {'success': True, 'item': []}
	m = re.findall('<a class="pl-video-title-link[^"]*?"[^>]*?href="([^"]*?)"[^>]*?>\s*(.*?)\s*</a>', content, re.DOTALL)
	for e in m:
		result['item'].append({'title': HTMLParser().unescape(e[1]), 'url': 'https://www.youtube.com' + e[0]})
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		result['item'].append({'title': 'Load more', 'url': 'https://www.youtube.com' + m.group(1)})
	return result

def uservideos(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 400'}
	result = {'success': True, 'item': []}
	m = re.findall('<h3 class="yt-lockup-title\s*">(.*?)</h3>', content, re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e, re.DOTALL)
		if m1 == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(m1.group(2)), 'url': 'https://www.youtube.com' + m1.group(1)})
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		result['item'].append({'title': 'Load more', 'url': 'https://www.youtube.com' + m.group(1)})
	return result

def userplaylists(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 500'}
	result = {'success': True, 'item': []}
	m = re.findall('<h3 class="yt-lockup-title\s*">(.*?)</h3>', content, re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?href="([^"]*?)".*?>(.*?)</a>', e, re.DOTALL)
		if m1 == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(m1.group(2)), 'url': 'https://www.youtube.com' + m1.group(1)})
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', content, re.DOTALL)
	if m:
		result['item'].append({'title': 'Load more', 'url': 'https://www.youtube.com' + m.group(1)})
	return result

def user(url):
	result = {'success': True, 'item': []}
	result['item'].append({'title': 'videos', 'url': url + '/videos'})
	result['item'].append({'title': 'playlists', 'url': url + '/playlists?view=1'})
	return result

def loadmore(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 300'}
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youtube 301'}
	result = {'success': True, 'item': []}
	m = re.findall('<h3 class="yt-lockup-title\s*">(.*?)</h3>', data['content_html'], re.DOTALL)
	for e in m:
		m1 = re.search('<a\s+.*?title="([^"]*?)".*?href="([^"]*?)".*?>.*?</a>', e, re.DOTALL)
		if m1 == None:
			continue
		result['item'].append({'title': HTMLParser().unescape(m1.group(1)), 'url': 'https://www.youtube.com' + m1.group(2)})
	m = re.findall('<a class="pl-video-title-link[^"]*?"[^>]*?href="([^"]*?)"[^>]*?>\s*(.*?)\s*</a>', data['content_html'], re.DOTALL)
	for e in m:
		result['item'].append({'title': HTMLParser().unescape(e[1]), 'url': 'https://www.youtube.com' + e[0]})
	m = re.search('<button\s+.*?class="[^"]*?browse-items-load-more-button[^"]*?".*?href="(.*?)".*?>.*?</button>', data['load_more_widget_html'], re.DOTALL)
	if m:
		result['item'].append({'title': 'Load more', 'url': 'https://www.youtube.com' + m.group(1)})
	return result
'''
def play1(url):
	try:
		para = parse_qs(urlparse(url).query)
		url = 'http://www.youtube.com/get_video_info?video_id=' + para['v'][0] + '&el=detailpage'
	except:
		return {'success': False, 'code':'youtube 100'}
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 101'}
	para = parse_qs(content)
	try:
		title = para['title'][0]
		content = para['url_encoded_fmt_stream_map'][0]
	except:
		return {'success': False, 'code':'youtube 102'}
	result = {'success': True, 'title': '', 'url': {}}
	contents = content.split(',')
	for content in contents:
		para = parse_qs(content)
		result['url'][para['type'][0]] = para['url'][0]
	return result

def play2(url):
	para = parse_qs(urlparse(url).query)
	try:
		url = 'https://www.youtube.com/watch?v=' + para['v'][0]
	except LookupError:
		xbmcgui.Dialog().ok('错误', '错误500')
		return
	content = httpget(url)
	if content == False:
		xbmcgui.Dialog().ok('错误', '错误501')
		return
	content = re.search('"adaptive_fmts":"(.*?)"', content, re.DOTALL)
	if content == None:
		xbmcgui.Dialog().ok('错误', '错误502')
		return
	content = content.group(1)
	content = '{"adaptive_fmts":"' + content + '"}'
	data = json.loads(content)
	content = data['adaptive_fmts']
	content = 'http://www.test.com/?' + content
	para = parse_qs(urlparse(content).query)
	i = 0
	for type in para['type']:
		item(type + ' ' + para['bitrate'][i], para['url'][i], False)
		i = i + 1
'''
def match1(text, *patterns):
	if len(patterns) == 1:
		pattern = patterns[0]
		match = re.search(pattern, text)
		if match:
			return match.group(1)
		else:
			return None
	else:
		ret = []
		for pattern in patterns:
			match = re.search(pattern, text)
			if match:
				ret.append(match.group(1))
		return ret

def tr_js(code):
	code = re.sub(r'function', r'def', code)
	code = re.sub(r'(\W)(as|if|in|is|or)\(', r'\1_\2(', code)
	code = re.sub(r'\$', '_dollar', code)
	code = re.sub(r'\{', r':\n\t', code)
	code = re.sub(r'\}', r'\n', code)
	code = re.sub(r'var\s+', r'', code)
	code = re.sub(r'(\w+).join\(""\)', r'"".join(\1)', code)
	code = re.sub(r'(\w+).length', r'len(\1)', code)
	code = re.sub(r'(\w+).slice\((\w+)\)', r'\1[\2:]', code)
	code = re.sub(r'(\w+).splice\((\w+),(\w+)\)', r'del \1[\2:\2+\3]', code)
	code = re.sub(r'(\w+).split\(""\)', r'list(\1)', code)
	return code

def decipher(js, s):
	js = js.replace('\n', ' ')
	f1 = match1(js, r'"signature",([$\w]+)\(\w+\.\w+\)')
	f1def = match1(js, r'function %s(\(\w+\)\{[^\{]+\})' % re.escape(f1)) or \
	match1(js, r'\W%s=function(\(\w+\)\{[^\{]+\})' % re.escape(f1))
	f1def = re.sub(r'([$\w]+\.)([$\w]+\(\w+,\d+\))', r'\2', f1def)
	f1def = 'function %s%s' % (f1, f1def)
	code = tr_js(f1def)
	f2s = set(re.findall(r'([$\w]+)\(\w+,\d+\)', f1def))
	for f2 in f2s:
		f2e = re.escape(f2)
		f2def = re.search(r'[^$\w]%s:function\((\w+,\w+)\)(\{[^\{\}]+\})' % f2e, js)
		if f2def:
			f2def = 'function ' + f2e + '(' + f2def.group(1) + ')' + f2def.group(2)
		else:
			f2def = re.search(r'[^$\w]%s:function\((\w+)\)(\{[^\{\}]+\})' % f2e, js)
			f2def = 'function ' + f2e + '(' + f2def.group(1) + ',b)' + f2def.group(2)
		f2 = re.sub(r'(\W)(as|if|in|is|or)\(', r'\1_\2(', f2)
		f2 = re.sub(r'\$', '_dollar', f2)
		code = code + 'global %s\n' % f2 + tr_js(f2def)
	f1 = re.sub(r'(as|if|in|is|or)', r'_\1', f1)
	f1 = re.sub(r'\$', '_dollar', f1)
	code = code + 'sig=%s(s)' % f1
	exec(code, globals(), locals())
	return locals()['sig']

def play3(url):
	content = httpget(url)
	if content == False:
		return {'success': False, 'code':'youtube 100'}
	m = re.search('ytplayer.config\s*=\s*({[^\n]+?});', content)
	if m == None:
		return {'success': False, 'code':'youtube 101'}
	content = m.group(1)
	try:
		data = json.loads(content)
	except:
		return {'success': False, 'code':'youtube 102'}
	result = {'success': True, 'title': '', 'url': {}}
	contents = ''
	for stream in data['args']['url_encoded_fmt_stream_map'].split(','):
		para = parse_qs(stream)
		if 's' in para:
			if contents == '':
				url = 'https://www.youtube.com' + data['assets']['js']
				contents = httpget(url)
				if contents == False:
					return {'success': False, 'code':'youtube 103'}
			sig = decipher(contents, para['s'][0])
			result['url'][para['type'][0]] = para['url'][0] + '&signature=' + sig
		else:
			result['url'][para['type'][0]] = para['url'][0]
	return result
